<?php

/**
 * To activate this extension, add the following into your LocalSettings.php file:
 * require_once('$IP/extensions/rdblinker.php');
 */
 
/**
 * Protect against register_globals vulnerabilities.
 * This line must be present before any global variable is referenced.
 */
if( !defined( 'MEDIAWIKI' ) ) {
        echo( "This is an extension to the MediaWiki package and cannot be run standalone.\n" );
        die( -1 );
}
 
// Extension credits that will show up on Special:Version    
$wgExtensionCredits['specialpage'][] = array(
        'name' => 'BaseLinker',
        'version' => 1.2,
        'author' => 'Juha Villman',
        'url' => 'http://en.opasnet.org/w/extension:baselinker',
        'description' => 'Creates SQL-query links to Opasnet Base',
        'descriptionmsg' => 'foobar-desc',
);
 
//Avoid unstubbing $wgParser on setHook() too early on modern (1.12+) MW versions, as per r35980
if ( defined( 'MW_SUPPORTS_PARSERFIRSTCALLINIT' ) ) {
        $wgHooks['ParserFirstCallInit'][] = 'efRDBParserInit';
} else { // Otherwise do things the old fashioned way
        $wgExtensionFunctions[] = 'efRDBParserInit';
}

$wgExtensionFunctions[] = 'efRDBParserFunction_Setup';
# Add a hook to initialise the magic word
$wgHooks['LanguageGetMagic'][]       = 'efRDBParserFunction_Magic';
 
function efRDBParserInit() {
        global $wgParser;
        $wgParser->setHook( 'sql-query', 'efRDBRender' );
        return true;
}

function efRDBParserFunction_Setup() {
        global $wgParser;
        # Set a function hook associating the "sql-query" magic word with our function
        $wgParser->setFunctionHook( 'sql-query', 'efRDBParserFunction_Render' );
}
 
function efRDBParserFunction_Magic( &$magicWords, $langCode ) {
        # Add the magic word
        # The first array element is case sensitive, in this case it is not case sensitive
        # All remaining elements are synonyms for our parser function
        $magicWords['sql-query'] = array( 0, 'sql-query' );
        # unless we return true, other parser functions extensions won't get loaded.
        return true;
}
 
function efRDBParserFunction_Render( &$parser, $param1 = '', $param2 = '' ) {
       # The parser function itself
       # The input parameters are wikitext with templates expanded
       # The output should be wikitext too
	//replace empty spaces and line breaks with string %20
	$param1=str_replace("\n","%20",$param1);
	$param1=str_replace(" ","%20",$param1);
	//replace " with '
	$param1=str_replace("\"","'",$param1);
	$link_text ="";
	//if param2 is not set then we use default
	if($param2=="") $link_text = "Run query in Opasnet Base";
	else $link_text = $param2;
	$output="<a href=\"http://base.opasnet.org/sqlbrowser.php?sql_query=".$param1."\">".$link_text."</a>";
	return $parser->insertStripItem( $output, $parser->mStripState );

}
 
function efRDBRender( $input, $args, $parser ) {
	//default link name
	$link_name = "Run query";
	//if custom name is set...
	if(isset($args['name'])) $link_name = $args['name'];
	//if we want to show query as PRE wikitext
	if($args['display']=="1")
	{    
		//first we place whole thing into a different variable
		$wiki_input = $input;
		//replace empty spaces and line breaks with string %20
		$input=str_replace("\n","%20",$input);
		$input=str_replace(" ","%20",$input);
		//replace " with '
		$input=str_replace("\"","'",$input);
		$input="<pre class=\"_fck_mw_lspace\">".$wiki_input."</pre><a href=\"http://www.pyrkilo.fi/resultdb/sqlbrowser.php?sql_query=".$input."\">".$link_name."</a>";
	}
	else //this is without query text
	{
		//replace empty spaces and line breaks with string %20
		$input=str_replace("\n","%20",$input);
		$input=str_replace(" ","%20",$input);
		//replace " with '
		$input=str_replace("\"","'",$input);
		$input="<a href=\"http://www.pyrkilo.fi/resultdb/sqlbrowser.php?sql_query=".$input."\">".$link_name."</a>";
	

	}
       return $input;
}
